#!/nfs/public/bin/sybperl
#
# Program:  hdassign1.pl       Description:  Assigns a helpdesk ticket to a
#                                            support person.
#
# This is part of the Helpdesk Management System written by Mark Mellman.
#
# Date last revision: 08/14/96   Version: 2.00

require "helpdesk.inc";

&helpdesk_login;
 
#####################################################
# pull apart buffer from hdassign.pl
#####################################################

$buffer=<STDIN>;
@pairs = split(/&/, $buffer);
 
foreach $pair (@pairs) {
  print "name=$name\n";
  ($name, $value) = split(/=/, $pair);
  $value=~ tr/+/ /;
  $value=~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $FORM{$name} = $value;
}
$ticket=$FORM{"ticket"};
$wvar=$FORM{"resolution"};
if(length($wvar) > 254) {
  $res=substr($wvar, 0, 255);
  $res1=substr($wvar, 255, length($wvar)-255);
} else {
  $res=$wvar;
  $res1=" ";
}
$assign=$FORM{"assignedTo"};
$keyw=$FORM{"keyWords"};
$stat=$FORM{"status"};
$times=$FORM{"timeSpent"};
if( $times == 0) {
  $times=0.0;
}

##############################################################
# Get information from the Owner table and put in an array
##############################################################

sub get_owner {
  &helpdesk_login;
  $str="select * from Owner";
  &dbcmd($dbproc, $str);
  &dbresults($dbproc);
  &dbsqlexec ($dbproc);
  $supid[0]=0;
  $supnam[0]="Same";
  $supema[0]="";
  $cnt=1;
  if(&dbresults($dbproc)==&SUCCEED) {
    while(@data1=&dbnextrow($dbproc)) {
      $supid[$cnt]=$data1[0];
      $supnam[$cnt]=$data1[1];
      $supema[$cnt]=$data1[2];
      $cnt=$cnt+1;
    }
  }
  $cnt=$cnt-1;
}

##############################################################
# Update the status of the master record (OTicket Table)
##############################################################

&get_owner;
$str= "update OTicket set status = \"$stat\" where ticketId = $ticket";
&do_isql;
if( $assign != 0 ) {
  $str= "update OTicket set assigned = \"$supnam[$assign]\", ";
  $str=$str . "ownerId = $assign where ticketId = $ticket";
  &do_isql;
}

##############################################################
# Insert detail record into detail table (CTicket Table)
##############################################################

&get_owner;
$str=  "insert CTicket\n " ;
$str = $str . "values ($ticket, \n";
$str = $str . "\"$res\",\n";
$str = $str . "getdate(), \"$supnam[$assign]\", \"$keyw\", \"$stat\",\n";
$str = $str . "\"$res1\", $times, $assign)";
&helpdesk_login;
&do_isql;
&do_mail;
print "Location: $CGIDIR/hdassign.pl?ticknum=&owner=$assign\n\n";

#########################################################
# Do the isql query
#########################################################
 
sub do_isql
{

  &dbcmd ( $dbproc, $str ) ;
  if ( &dbsqlexec ($dbproc) != &SUCCEED )
  {
    print "Error executing command\n" ;
  }
  &dbresults($dbproc);
}

######################################################
# E-mail the customer with update information
######################################################

sub do_mail
{
  $str= "select * from OTicket where ticketId = $ticket";
  &do_isql;
  @data=&dbnextrow($dbproc); 
  $assign=$data[13];
  &get_owner;  
  $mailtostr=$supema[$assign];
  if( $data[12] ne "NULL") {
    $mailtostr = $mailtostr.", ".$data[12];
  }
  
  open (NEWREQ, "| /usr/bin/mail -t $mailtostr");
  printf NEWREQ "From: %s
Subject: Update on request number %d
 
Problem Description:
 
%s %s

========================================

Update:

%s %s\n", $supema[$assign], $ticket, $data[6], $data[7], $res, $res1; 
  close(NEWREQ);
}
