#!/nfs/public/bin/sybperl
#
# Program:  hdopen.pl      Description:  Display list of assigned ticket for
#                                        support personnel (things to do 
#                                        list).
#
# This is part of the Helpdesk Management System written by Mark Mellman.
#
# Date last revision: 08/16/96   Version: 2.00

require "helpdesk.inc";

&helpdesk_login;
&get_owner;

########################################################
#  Pull apart the information for hdopen.html
########################################################

$buffer=$ENV{'QUERY_STRING'};
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
  ($name, $value) = split(/=/, $pair);
  $value=~ tr/+/ /;
  $value=~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $FORM{$name} = $value;
}
$owner=$FORM{"owner"};

########################################################
#  Query and display the results
########################################################

$str="select ticketId, convert(varchar, datepart(month, submitDate))+\"/\"+convert(varchar, datepart(day, submitDate))+\"/\"+convert(varchar,datepart(year, submitDate)), ";
$str=$str."dateNeededBy, status, department, problemType, requestDescription, requestDescription2, ";
$str=$str."submitFirstName, submitLastName, priority, assigned from OTicket ";
$str=$str."where status != \"U\" and status != \"C\" and ownerId = $owner order by priority DESC, submitDate, dateNeededBy";
&do_isql;
&page_head;
$person="";
$nol=0;
while(@data=&dbnextrow($dbproc)) {
  &print_detail(@data);
  $nol=$nol+1;
}
if($nol != 0) { &print_not($nol)};

print "</html>\n";

#########################################################
#  Do the isql query
#########################################################

sub do_isql
{
   &dbcmd($dbproc, $str);
   if (&dbsqlexec ($dbproc) !=&SUCCEED)
   {
      print "Error executing command\n";
   }
   &dbresults($dbproc);
}

#########################################################
#  Display the page heading
#########################################################

sub page_head
{
  $tmp=$owner;
  $dt=&ctime(time);
  print "Content-type: text/html\n\n";
  print "<pre>\n";
  print "                       Open Trouble Tickets for $supnam[$tmp]\n";
  print "                                 Report Run on\n";
  printf "                      %s",$dt;
  print "-----------------------------------------------------------------------------\n";
}

#########################################################
#  Display the detail line
#########################################################

sub print_detail
{
  @data=@_;
  $nam=$data[8]." ".$data[9];
  printf "<table border>
  <tr><td>Ticket</td><td>Submitter</td><td>Dept</td><td>Req Date</td><td>Need By</td><td>Priority</td></tr>
  <tr><td>%6.6d</td><td>%-16s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td></tr>
  <tr><td colspan=6>Description:</td></tr>
  <tr><td colspan=6>%s %s</td></tr>
  </td></tr>
  </table>", $data[0], $nam, $data[4], $data[1], $data[2], $data[10], $data[6], $data[7];
}

#########################################################
#  Print the number of tickets total line
#########################################################

sub print_not
{
  $num=$_[0];
  print "\nTotal Number of Tickets for owner: $num\n";
  print "\n================================\n";
}

########################################################
#  Build array with support personnel info
########################################################

sub get_owner {
  &helpdesk_login;
  $str="select * from Owner";
  &dbcmd($dbproc, $str);
  &dbresults($dbproc);
  &dbsqlexec ($dbproc);
  $cnt=1;
  if(&dbresults($dbproc)==&SUCCEED) {
    while(@data=&dbnextrow($dbproc)) {
      $supid[$cnt]=$data[0];
      $supnam[$cnt]=$data[1];
      $supema[$cnt]=$data[2];
      $cnt=$cnt+1;
    }
  }
  $cnt=$cnt-1;
}

